#include <stdio.h>
#include <math.h>
#define n 30000              // s82 star number
#define bok 48.              // standard SCHMIDT system,type=1  
#define r05  1.0             // 1 arcsec 
float  buf[13000*13000];
char   head[72][80],f1[30],f3[30],b[30],c[80],d[150], mark[n],c0=34,c1=37,cc;
char   e[150],ty;
FILE   *fp,*fp1,*fp2,*fp3;
double a8[8],b8[8],xx[n],yy[n],x,y,x3,x4,r,cx,cy,pi;  // position s82
float  s82[n],ber[n],arr[n],drr[n],sky,see,gain,rdno,x1,x2,ava,sig,z1,z2;  
float  u73,g73,u_g,xx1;
int    n1,n2, i0,i1,i2,ic, m,pg=0,cg=0; // int ccd;
float  scale,r0;
char   cs82[n][33];
float  dx2[n];

main(int ac,char **av)
{
  int i,j,k,kp=0;
  if(ac<2){
    printf("\n\t******* use S82(Med) to calibrating & check matched******\n");
    printf("\n\tUsage: c9s82 *.fit [!,#,%,$]\n");
    printf("\n\t mag: 15~~21.5 +addzouhu judge\n");
    printf("\n\t ! /xw  % /xw  g /jg(\n\n");
    exit(0);
  }
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  system("cp /vega2/rhbin/uefault.param default.param");
  system("cp /vega2/rhbin/uefault.conv default.conv");
  system("cp /vega2/rhbin/uefault.nnw default.nnw");
  cc=av[ac-1][0]; 
  if(cc=='!' || cc=='%' || cc=='g'){ ac--; pg=1; }
                
  for(i=1;i<ac;i++){
    strcpy(f1,av[i]);
    printf("%3d: %s ******\n",i,f1);
    fp=fopen(f1,"rb+");
    if(fp==0){ printf("not found!\n");  continue; }
    fread(head,72,80,fp);
    k=indexpos(head,"A81     ",72);
    for(j=0;j<8;j++)sscanf(&head[k+j][10],"%lf",&a8[j]);
    xytoad(a8,b8);
    sscanf(&head[3][20],"%d",&n1);
    sscanf(&head[4][20],"%d",&n2);
    k=indexpos(head,"SCALE   ",72);
    if(k==72){ printf("\n\t Scale not found!\n"); exit(0); }
    else sscanf(&head[k][20],"%f",&scale);
/*
    k=indexpos(head,"CCD_NO: ",72); sscanf(&head[k][15],"%d",&ccd);
    k=indexpos(head,"SEEING  ",72); sscanf(&head[k][15],"%f",&see);
    k=indexpos(head,"GAIN    ",72); 
    sscanf(&head[k][10],"%f %f %lf %lf",&x1,&x2,&x3,&x4); gain=(x1+x2+x3+x4)/4.
    
    strncpy(b,&head[6][53],25);
    for(j=0;j<9;j++)if(b[j]==32)break;
    if(j!=9){ printf("not coordinated!\n"); continue; }
*/
    rdno=8.5;
    see=2.0; gain=1.8;
    for(j=0;j<13;j++){ b[j]=head[11][17+j]; b[j+13]=head[12][17+j]; } b[26]=0;
    k=n1; if(n1<n2)k=n2;
    z1=k*scale; z1/=60.; z1+=0.5; k=z1;
    r0=r05/scale;
    sprintf(c,"s82 %s %d c9.s82 22.0",b,k);
    system(c);                    
    m=0;
    fp1=fopen("c9.s82","r");
l10:
    fgets(d,150,fp1); if(feof(fp1))goto l20;
    if(d[0]=='#')goto l10;
    sscanf(&d[37],"%f%f",&s82[m],&arr[m]);  mark[m]=0;
    if(arr[m]>0.05)goto l10;
    chs(&d[5],&x3);  chs(&d[18],&x4);
    rad_xy(a8[6],a8[7],x3,x4,&x,&y,2,0);
    if(x<10. || x>n1-10.)goto l10;
    if(y<10. || y>n2-10.)goto l10;
    d[32]=0; strcpy(cs82[m],d);
    xx[m]=x; yy[m]=y;
    if(m<n)m++;
    goto l10;
l20:
    fclose(fp1); 
    if(m<2){ printf("less U standard star in this area\n"); k=0; goto l6; }
  
    fp2=fopen("/vega2/rhbin/uefault.sex","r");
    fp1=fopen("default.sex","w");
l30:
    fgets(c,80,fp2); if(feof(fp2))goto l40;
    if(c[0]=='G'&&c[1]=='A'&&c[2]=='I'){sprintf(&c[6],"%4.1f",gain);c[10]=9;}
    if(c[0]=='S'&&c[1]=='E'&&c[2]=='E'){sprintf(&c[12],"%5.2f",see);c[17]=9;}
    fputs(c,fp1); goto l30;
l40:
    fclose(fp1);
    sprintf(c,"sex %s",f1);
    system(c);                           // get test.cat
    fp1=fopen("test.cat","r");
l50:
    fgets(d,150,fp1);  if(feof(fp1))goto l60;
    if(d[0]=='#')goto l50;
    sscanf(&d[48],"%f %f %lf %lf",&x1,&x2,&x3,&x4);
    if(x1>25.)goto l50;
    r=r0;                      // err 1 pixel, 0.454"
    for(j=0;j<m;j++){
      x=xx[j]-x3; x*=x; 
      y=yy[j]-x4; y*=y; 
      x=sqrt(x+y);
      if(x<r){r=x; k=j; }
    } 
    if(r!=r0){
      ber[k]=s82[k]-x1; drr[k]=1./(x2*x2+arr[k]*arr[k]);
                                // 15--21.5
      mark[k]=2; if(s82[k]>21.5 || s82[k]<15.)mark[k]=1;
      dx2[k]=x2;
    } goto l50;
l60:
    fclose(fp1);
    printf("s82: %4d  1.0%c_match: ",m,c0);
l70:
    x1=x2=xx1=0.;
    for(j=k=0;j<m;j++)if(mark[j]==2){ k++; x1+=ber[j]*drr[j]; xx1+=drr[j]; }
    printf(" %4d ",k);
    ava=x1/xx1;  
    for(j=0;j<m;j++)if(mark[j]==2) x2+=(ber[j]-ava)*(ber[j]-ava);
    sig=sqrt(x2/k); 
    printf(" av: %6.3f %6.3f\n",ava,sig);
    sig*=3.;
    for(j=ic=0;j<m;j++)if(mark[j]==2){
      x2=ber[j]-ava; if(x2<0.)x2=-x2;
      if(x2>sig){ mark[j]=1; ic++; }
    }
    if(ic){ printf("\t  3_sigma_match: "); goto l70;  }
    sig/=3.;  r=pow(10,(ava-4.)*0.4);
    sprintf(&head[59][0],"CALIS82 =%21.3f / rms:%5.3f  s82:%4d  matched:%4d  W:%7.4lf",
     ava,sig,m,k,r);    for(j=77;j<80;j++)head[59][j]=32;
    printf("CALIS82 =%8.3f  Weight: %7.4lf\n",ava,r);
    if(k<6) printf("******* less matched (<6)\n");
l6:
   if(k<6){                   // 20120828
     sprintf(&head[59][0],"CALIS82 =                4.000 /");
     for(j=32;j<80;j++)head[29][j]=32;
   }
// mark==2, 16-20.5 mastched star, use to cal seeing
    fread(buf,n1*n2,4,fp); swap4(buf,n1*n2*4);
    j=indexpos(head,"SKYADU  ",72); sscanf(&head[j][20],"%f",&sky);
   if(k){                     // 20120828
    seeing(buf,n1,n2,xx,yy,mark,m,sky,&see,scale);
    printf("SKY: %7.2f  Seeing:  %5.2f\n",sky,see);
    sprintf(&head[j+1][0],"SEEING  =%21.3f /",see); head[j+1][32]=32;
   }
    fseek(fp,0,0); fwrite(head,72,80,fp);
    fclose(fp);
    if(k<9)continue;
    if(pg){
      i0=0; i1=1;
      if(cc=='!'|| cc=='%')pgbegin_(&i0,"/xw",&i1,&i1,3);
      if(cc=='g')pgbegin_(&i0,"/jg",&i1,&i1,3);
      if(cc=='%'){
        x1=610., x2=600.;        pgpap_(&x1,&x2);
        x1=z1=0.; x2=8640.; z2=8200.;  pgenv_(&x1,&x2,&z1,&z2,&i0,&i0);
        pglabel_("s82-ber-cali_mag, red circle under AV","15.~~21.5m",f1,37,10,strlen(f1));
        for(j=0;j<m;j++)if(mark[j] && s82[j]>15. && s82[j]<21.5){
          z1=xx[j]; z2=yy[j]; pgpoint_(&i1,&z1,&z2,&i1);
          x1=(ber[j]-ava)*9.;
          ic=2; if(x1<0.){ x1=-x1; ic=1; }   pgsci_(&ic);
          i2=x1+0.5; i2+=21;
          if(i2<27){ z1=xx[j]; z2=yy[j]; pgpoint_(&i1,&z1,&z2,&i2); }
        } pgend_();        continue;
      }
      x1=600., x2=600.;        pgpap_(&x1,&x2);
      x1=14.; x2=23.; z1=10.; z2=19.;
      pgsci_(&i1); pgenv_(&x1,&x2,&z1,&z2,&i0,&i0);
      pglabel_("S82st_median_mag","Bert(Best) mag",f1,16,14,strlen(f1));
      sprintf(c,"cali:%9.3f  rms:%9.3f  %d/%d",ava,sig,k,m);
      x1=14.5; z1=18.0; pgtext_(&x1,&z1,c,strlen(c));
      sprintf(c,"skyadu:  %9.2f",sky);
      x1=14.5; z1=17.5; pgtext_(&x1,&z1,c,strlen(c));
      sprintf(c,"seeing:%9.2f",see);
      x1=14.5; z1=17.0; pgtext_(&x1,&z1,c,strlen(c));
    strcpy(f3,f1); f3[strlen(f3)-3]=0; strcat(f3,"cali"); fp3=fopen(f3,"w");
    fprintf(fp3,"#MARK: 2: green;  1: outofmag/3sigma   X    Y  S82(med) err Ber(Best) err Mark\n#");
    for(j=0;j<76;j++)fprintf(fp3,"-"); fprintf(fp3,"\n");

      for(j=0;j<m;j++)if(mark[j]){
        ic=mark[j]*2; if(ic<0)ic=-ic; ic--; pgsci_(&ic);
        x1=s82[j]; x2=s82[j]-ber[j];
        pgpoint_(&i1,&x1,&x2,&i1);
      fprintf(fp3,"%s%8.2lf%8.2lf%7.3f%6.3f%7.3f%6.3f%3d\n",
             cs82[j],xx[j],yy[j],s82[j],arr[j],x2,dx2[j],mark[j]);
      } fclose(fp3);
      pgend_();
      if(cc=='g'){
        strcpy(b,f1); b[0]='a';
        j=strlen(b)-3; b[j++]='g'; b[j++]='i'; b[j]='f';
        if(kp==0)sprintf(c,"mv pgplot.gif %s",b);
        else     sprintf(c,"mv pgplot%d.gif %s",kp%10,b);
        system(c); kp++;
        printf("%s\n",c);
      }
    }    
  }
}

seeing(map,n1,n2,xx,yy,mark,m,sky,see,scale)
char  *mark;
int   n1,n2,m;
float map[n2][n1],sky,*see,scale;
double *xx,*yy;
{
  short d[2000];
  float z,s1,s2;
  int i,j,k,ix,iy,b[113],l,ip;

  for(l=ip=0;ip<m;ip++)if(mark[ip]==2){
    ix=xx[ip]+0.5; iy=yy[ip]+0.5;
    for(j=0,i=ix-14;i<=ix+14;i++,j+=4){
    z=0.; for(k=-2;k<=2;k++)z+=map[iy+k][i]-sky; b[j]=z; }
    for(j=0;j<112;j+=4)b[j+2]=(b[j]+b[j+4])/2.+0.5;
    for(j=0;j<112;j+=2)b[j+1]=(b[j]+b[j+2])/2.+0.5;
    for(j=0;j<112;j++)if(b[j]<0)b[j]=0;
    histat(b,&z,&s1,112);

    for(j=0,i=iy-14;i<=iy+14;i++,j+=4){
    z=0.; for(k=-2;k<=2;k++)z+=map[i][ix+k]-sky; b[j]=z; }
    for(j=0;j<112;j+=4)b[j+2]=(b[j]+b[j+4])/2.+0.5;
    for(j=0;j<112;j+=2)b[j+1]=(b[j]+b[j+2])/2.+0.5;
    for(j=0;j<112;j++)if(b[j]<0)b[j]=0;
    histat(b,&z,&s2,112);
    k=(s1+s2)/8.*2.355*100.+0.5;          // expand 100
    if(k >100 && k<999 )d[l++]=k;
    if(l>=2000)break;
  }
  white_black(d,1,l,&z,&s1); z*=0.01;        // shrink 100
  *see=z*scale;
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[128];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

rad_xy(ac,dc,ra,de,x,y,type,k)
double ac,dc,ra,de,*x,*y;  int type,k;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
/*                         // same discribe formula as following 3 lines
  double sd,cd,td,co;      // china bai_ke_quan_shu (astronmy) p.552
  sd=sin(dc);  cd=cos(dc);  td=tan(der);
  co=cos(rar-ac);  tmp=sd*td+cd*co;
  xi=sin(rar-ac)/tmp;
  xn=(cd*td-sd*co)/tmp;
*/
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  if(type==1){     // schmidt TELESCOPE
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=atan(tmp)/tmp;
      xi*=tmp; xn*=tmp;
    }
  }
  if(type==2){    //  BOK telescope
    tmp=1.+bok*(xi*xi+xn*xn);
    xi*=tmp; xn*=tmp;
  }
  if(k==0){
    *x=b8[0]*xi+b8[2]*xn+b8[4];
    *y=b8[1]*xi+b8[3]*xn+b8[5];
  }
  if(k==1){ *x=xi; *y=xn;}
}

xy_rad(ac,dc,x,y,ra,de,type,k)
double ac,dc,x,y,*ra,*de;  int type,k;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  if(type==1){
    tmp=sqrt(xi*xi+xn*xn);
    if(tmp!=0.){
      tmp=tan(tmp)/tmp;
      xi*=tmp;  xn*=tmp;
    }
  }
  if(type==2){
    tmp=1.+bok*(xi*xi+xn*xn);
    for(i=0;i<4;i++){
      x1=xi/tmp; y1=xn/tmp;
      tmp=tan(dc);  tmp1=1.-y1*tmp;
      r1=atan(x1/cos(dc)/tmp1);
      d1=atan((y1+tmp)*cos(r1)/tmp1);
      r1+=ac;
      tmp=atan(tan(d1)/cos(r1-ac));
      x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
      y1=tan(tmp-dc);
      tmp=1.+bok*(x1*x1+y1*y1);
//                                 printf("%lf\n",tmp);
    }
    xi/=tmp; xn/=tmp;
  }
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  if(k==0){ *ra/=cx; *de/=cy; }
}
